#include "3d.h"


HRESULT InitD3D()
{
	// D3D9̍쐬
	if( NULL == ( g_pD3D = Direct3DCreate9( D3D_SDK_VERSION ) ) )
	{
		return E_FAIL;
	}

	// D3D9foCX̍쐬i\Ȃn[hEFAT&Lgpj
	D3DPRESENT_PARAMETERS d3dpp; 
	ZeroMemory( &d3dpp, sizeof(d3dpp) );
	d3dpp.Windowed = TRUE;
	d3dpp.SwapEffect = D3DSWAPEFFECT_DISCARD;
	d3dpp.BackBufferFormat = D3DFMT_UNKNOWN;
	d3dpp.EnableAutoDepthStencil = TRUE;
	d3dpp.AutoDepthStencilFormat = D3DFMT_D16;

	if( FAILED( g_pD3D->CreateDevice(
		 D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, g_hWnd, D3DCREATE_HARDWARE_VERTEXPROCESSING, &d3dpp, &g_pd3dDevice ) )
	)
	{
		if( FAILED( g_pD3D->CreateDevice( 
			D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, g_hWnd, D3DCREATE_SOFTWARE_VERTEXPROCESSING, &d3dpp, &g_pd3dDevice ) )
		)
		{
			return E_FAIL;
		}
	}

	// _Oݒ
	SetRender();

	return S_OK;
}


void SetRender()
{
	// Zobt@[Lɂ
	g_pd3dDevice->SetRenderState( D3DRS_ZENABLE, TRUE );  
	// JO͂Ȃ
	g_pd3dDevice->SetRenderState( D3DRS_CULLMODE, D3DCULL_NONE );
	// CgLɂ
	g_pd3dDevice->SetRenderState( D3DRS_LIGHTING, TRUE );
	// ArGgCgijݒ肷
	g_pd3dDevice->SetRenderState( D3DRS_AMBIENT, 0xffffffff );
	// XyLiʔˁjLɂ
	g_pd3dDevice->SetRenderState(D3DRS_SPECULARENABLE,TRUE);

#if	ALPHATMODE
	//{bNX𓧖Ƀ_ÔŃAt@ufBOݒ肷
	g_pd3dDevice->SetRenderState ( D3DRS_ALPHABLENDENABLE, TRUE );	
	g_pd3dDevice->SetRenderState ( D3DRS_SRCBLEND, D3DBLEND_SRCALPHA );
	g_pd3dDevice->SetRenderState ( D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA );
	g_pd3dDevice->SetRenderState ( D3DRS_ALPHATESTENABLE, TRUE );
#endif


#if	RIGHTMODE
	// CgĂ Fŋʔ˂ɐݒ
	D3DXVECTOR3 vecDirection( 1, -0.5, 1 );
	D3DLIGHT9 light;
	ZeroMemory( &light, sizeof(D3DLIGHT9) );
	light.Type		 = D3DLIGHT_DIRECTIONAL;
	light.Diffuse.r  = 0.4f;
	light.Diffuse.g  = 0.4f;
	light.Diffuse.b  = 0.4f;	
	light.Specular.r = 1.0f;
	light.Specular.g = 1.0f;
	light.Specular.b = 1.0f;
	D3DXVec3Normalize( (D3DXVECTOR3*)&light.Direction, &vecDirection );
	light.Range	     = 200.0f;
	g_pd3dDevice->SetLight( 0, &light );
	g_pd3dDevice->LightEnable( 0, TRUE );	 
#endif

}


void CleanUp()
{
	// }eA
	if( charactor.Mat != NULL )	delete[]	charactor.Mat;

	// eNX`
	if( charactor.Tex != NULL )
	{
		for( DWORD i = 0 ; i < charactor.NumMaterial ; i++ )
		{
			if( charactor.Tex[i] )	charactor.Tex[i]->Release();
		}
	}

	if( g_pd3dDevice != NULL )	g_pd3dDevice->Release();
	if( g_pD3D != NULL )		g_pD3D->Release();
}
